package net.rumati.logging.muffero;

import java.util.LinkedList;
import java.util.List;
import java.util.Stack;
import net.rumati.logging.muffero.util.ConservativeInheritableThreadLocal;

public class NDC
{
    private static final ConservativeInheritableThreadLocal<Stack<String>> stacks = new ConservativeInheritableThreadLocal<Stack<String>>() {

        @Override
        protected Stack<String> create()
        {
            return new Stack<String>();
        }
    };

    private NDC(){}

    public static void push(String key)
    {
        stacks.get(true).push(key);
    }

    public static String pop()
    {
        Stack<String> stack = stacks.get();
        if (stack != null){
            return stack.pop();
        }else{
            return null;
        }
    }

    public static void pop(String key)
    {
        while (true){
            String top = pop();
            if (top == null){
                break;
            }else if (top.equals(key)){
                break;
            }
        }
    }

    public static List<String> getCopyOfStack()
    {
        List<String> retv = new LinkedList<String>();
        Stack<String> stack = stacks.get();
        if (stack != null){
            retv.addAll(stack);
        }
        return retv;
    }
}
