package net.rumati.logging.muffero.util;

import java.util.LinkedList;
import java.util.List;
import net.rumati.logging.muffero.LifeCycle;

public class AbstractAggregatedLifeCycle
    implements LifeCycle
{
    private final List<LifeCycle> objects = new LinkedList<LifeCycle>();

    protected synchronized final void addLifeCycleObject(Object o)
    {
        if (o instanceof LifeCycle){
            objects.add(LifeCycle.class.cast(o));
        }
    }

    public synchronized final void shutdown()
    {
        for (LifeCycle l : objects){
            l.shutdown();
        }
    }
}
